VERSION 5.00
Begin VB.Form frmPrettyPrint 
   AutoRedraw      =   -1  'True
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Pretty Print Converter"
   ClientHeight    =   4050
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9600
   Icon            =   "PrettyPt.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   270
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   640
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   285
      Index           =   2
      Left            =   7320
      TabIndex        =   6
      Text            =   "12/3/4/5/6/"
      Top             =   2400
      Width           =   2175
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Index           =   1
      Left            =   7320
      TabIndex        =   5
      Text            =   "12345^/*+"
      Top             =   1680
      Width           =   2175
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Index           =   0
      Left            =   7320
      TabIndex        =   3
      Text            =   "12432^+^8/436^//^"
      Top             =   960
      Width           =   2175
   End
   Begin VB.CommandButton cmdConvert 
      Caption         =   "Convert to Pretty Print"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   3600
      Width           =   9375
   End
   Begin VB.TextBox txtInput 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "14362/+^/83^42^/*"
      Top             =   3240
      Width           =   9375
   End
   Begin VB.Shape Shape1 
      Height          =   2775
      Left            =   120
      Top             =   120
      Width           =   7095
   End
   Begin VB.Label Label3 
      Caption         =   "((((1/2)/3)/4)/5)/6"
      Height          =   255
      Index           =   2
      Left            =   7320
      TabIndex        =   9
      Top             =   2160
      Width           =   1935
   End
   Begin VB.Label Label3 
      Caption         =   "1+2*(3/4^5)"
      Height          =   255
      Index           =   1
      Left            =   7320
      TabIndex        =   8
      Top             =   1440
      Width           =   1935
   End
   Begin VB.Label Label3 
      Caption         =   "1^(((2^(4+3^2)/8)/(4/(3^6))"
      Height          =   255
      Index           =   0
      Left            =   7320
      TabIndex        =   7
      Top             =   720
      Width           =   1935
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Copy and Paste to Try:"
      Height          =   255
      Left            =   7320
      TabIndex        =   4
      Top             =   240
      Width           =   2175
   End
   Begin VB.Label Label1 
      Caption         =   "RPN Equation:  Example = 1/(4^(3+6/2))*(8^3)/(4^2)"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   3000
      Width           =   4215
   End
End
Attribute VB_Name = "frmPrettyPrint"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'   ______________________________________________________
'  /|                                                     |
' | | Pretty Print                                        |
' | |      By Yi Lang Mok ylmpgmmg@hotmail.com            |
' | |_____________________________________________________|
' |/______________________________________________________/
'
'Example of Pretty Print Algorithm
' - Handles only one digit numbers for simplicity
' - Does not do centering - should be easy to implement (but for fractions? align where?)
' - Has to implement parenthesis
'       - Everytime there is a multiplication, set the parenthesis flag in
'         Str1 and/or Str2 if they are pointers
'       - i.e. multiplication of expressions -> bracket them

Option Explicit

Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" _
    (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, _
    ByVal lpString As String, ByVal nCount As Long) As Long

Const CHARHEIGHT = 10
Const CHARDROP = 3

Private Type eqnObj
    Height As Integer
    Width As Integer
    Str1 As String
    Op As String
    Str2 As String
    Paren As Integer
End Type

Dim eqnObject() As eqnObj                       'Equation objects
Dim eqnLength As Integer                        'Number of equation objects
Dim strList() As String * 1                     'Stack for numbers/variables
Dim strLength As Integer                        'Number of stack elements

Private Sub cmdConvert_Click()
Dim x As Integer
Dim curToken As String * 1

    ReDim strList(Len(txtInput.Text))           'Max number of numbers < Length of equation
    ReDim eqnObject(Len(txtInput.Text) \ 2)     'Max number of equations = number of ops < 0.5 * Length of equation
    eqnLength = 0
    strLength = 0
    Cls
    
    For x = 1 To Len(txtInput.Text)
        curToken = Mid(txtInput.Text, x, 1)
        Select Case curToken
        Case "0" To "9"                         'The token is a number -> add to stack
            Push curToken
        Case Else                               'The token is an operator -> create an equation object
            CreateEquation Pop, curToken, Pop
            Push Chr(eqnLength - 1)             'Add the pointer to the equation to the stack
        End Select
    Next
    
    DrawEquation eqnObject(eqnLength - 1), 20, 20
End Sub

Private Sub Push(Char As String)                'Adds an element to the stack
    strList(strLength) = Char
    strLength = strLength + 1
End Sub

Private Function Pop() As String                'Returns an element from the stack
    strLength = strLength - 1
    Pop = strList(strLength)
End Function

Private Sub CreateEquation(Str2 As String, Op As String, Str1 As String)    'Reverse Str1 and Str2 for Pop
Dim H1 As Integer
Dim H2 As Integer
Dim W1 As Integer
Dim W2 As Integer

    If (Str1 < "0" Or Str1 > "9") Then          'Determine the height and width of Str1
        H1 = eqnObject(Asc(Str1)).Height
        W1 = eqnObject(Asc(Str1)).Width
    Else
        H1 = CHARHEIGHT
        W1 = TextWidth(Str1)
    End If
    
    If (Str2 < "0" Or Str2 > "9") Then          'Determine the height and width of Str2
        H2 = eqnObject(Asc(Str2)).Height
        W2 = eqnObject(Asc(Str2)).Width
    Else
        H2 = CHARHEIGHT
        W2 = TextWidth(Str2)
    End If
    
    With eqnObject(eqnLength)
        Select Case Op                          'Determine the height and width of the equation
        Case "+", "-", "*"
            .Height = Max(H1, H2)
            .Width = W1 + W2 + TextWidth(" " & Op & " ")
        Case "/"
            .Height = H1 + H2 + 3
            .Width = Max(W1, W2) + 2
        Case "^"
            .Height = H1 + H2 - CHARDROP
            .Width = W1 + W2 + 1
        End Select
    
    .Str1 = Str1                                'Sets the equation fields
    .Str2 = Str2
    .Op = Op
    
    End With
    
    eqnLength = eqnLength + 1
End Sub

Private Sub DrawEquation(eqn As eqnObj, x As Integer, y As Integer)     'Draws the equation by recursing
Dim H1, W1 As Integer
    
    With eqn
        If (.Str1 < "0" Or .Str1 > "9") Then        'Determine the width and height of Str1
            H1 = eqnObject(Asc(.Str1)).Height       'Used to determine the position to draw Str2
            W1 = eqnObject(Asc(.Str1)).Width
        Else
            H1 = CHARHEIGHT
            W1 = TextWidth(.Str1)
        End If
        
        If (.Str1 < "0" Or .Str1 > "9") Then
            If (.Str2 < "0" Or .Str2 > "9") Then    'Both are pointers
                Select Case .Op
                Case "+", "-", "*"
                    DrawEquation eqnObject(Asc(.Str1)), x, y + .Height - H1
                    TextOut hdc, x + W1 + TextWidth(" "), y + .Height - CHARHEIGHT, .Op, 1
                    DrawEquation eqnObject(Asc(.Str2)), x + W1 + TextWidth(.Op) + 2 * TextWidth(" "), y + .Height - eqnObject(Asc(.Str2)).Height
                Case "/"
                    DrawEquation eqnObject(Asc(.Str1)), x + (.Width - W1) / 2, y
                    DrawEquation eqnObject(Asc(.Str2)), x + (.Width - eqnObject(Asc(.Str2)).Width) / 2, y + eqnObject(Asc(.Str1)).Height + 3
                    Line (x, y + H1 + 2)-(x + .Width, y + H1 + 2)
                Case "^"
                    DrawEquation eqnObject(Asc(.Str1)), x, y + .Height - eqnObject(Asc(.Str1)).Height
                    DrawEquation eqnObject(Asc(.Str2)), x + W1 + 1, y
                End Select
            Else                                    'Str1 is pointer
                Select Case .Op
                Case "+", "-", "*"
                    DrawEquation eqnObject(Asc(.Str1)), x, y + .Height - H1
                    TextOut hdc, x + W1 + TextWidth(" "), y + .Height - CHARHEIGHT, .Op + " " + .Str2, 3
                Case "/"
                    DrawEquation eqnObject(Asc(.Str1)), x + (.Width - W1) / 2, y
                    TextOut hdc, x + (.Width - TextWidth(.Str2)) / 2, y + eqnObject(Asc(.Str1)).Height + 3, .Str2, 1
                    Line (x, y + H1 + 2)-(x + .Width, y + H1 + 2)
                Case "^"
                    DrawEquation eqnObject(Asc(.Str1)), x, y + .Height - eqnObject(Asc(.Str1)).Height
                    TextOut hdc, x + W1 + 1, y, .Str2, 1
                End Select
            End If
        Else
            If (.Str2 < "0" Or .Str2 > "9") Then    'Str2 is pointer
                Select Case .Op
                Case "+", "-", "*"
                    TextOut hdc, x, y + .Height - CHARHEIGHT, .Str1 & " " & .Op, 3
                    DrawEquation eqnObject(Asc(.Str2)), x + W1 + TextWidth(.Op) + 2 * TextWidth(" "), y
                Case "/"
                    TextOut hdc, x + (.Width - W1) / 2, y, .Str1, 1
                    DrawEquation eqnObject(Asc(.Str2)), x + (.Width - eqnObject(Asc(.Str2)).Width) / 2, y + CHARHEIGHT + 3
                    Line (x, y + H1 + 2)-(x + .Width, y + H1 + 2)
                Case "^"
                    TextOut hdc, x, y + .Height - CHARHEIGHT, .Str1, 1
                    DrawEquation eqnObject(Asc(.Str2)), x + W1 + 1, y
                End Select
            Else                                    'Neither are pointers
                Select Case .Op
                Case "+", "-", "*"
                    TextOut hdc, x, y + .Height - CHARHEIGHT, .Str1 & " " & .Op & " " & .Str2, 5
                Case "/"
                    TextOut hdc, x + (.Width - W1) / 2, y, .Str1, 1
                    TextOut hdc, x + (.Width - TextWidth(.Str2)) / 2, y + CHARHEIGHT + 3, .Str2, 1
                    Line (x, y + H1 + 2)-(x + .Width, y + H1 + 2)
                Case "^"
                    TextOut hdc, x, y + .Height - CHARHEIGHT, .Str1, 1
                    TextOut hdc, x + W1 + 1, y, .Str2, 1
                End Select
            End If
        End If
    End With
End Sub

Private Function Max(a As Integer, b As Integer)
    If a > b Then Max = a Else Max = b
End Function

